SystemOrganization addCategory: #'LRSTM-Model'!
SystemOrganization addCategory: #'LRSTM-Model-Errors'!

!SequenceableCollection methodsFor: '*LRSTM-Model' stamp: 'lr 6/7/2007 15:14'!
atomicReplaceFrom: start to: stop with: replacement startingAt: repStart
	| index repOff |
	repOff := repStart - start.
	index := start - 1.
	[ (index := index + 1) <= stop ]
		whileTrue: [ self at: index put: (replacement at: repOff + index) ]! !

!WriteStream methodsFor: '*LRSTM-Model' stamp: 'StefanMarr 12/4/2011 22:17'!
atomicNextPut: anObject
	((collection class == ByteString) and: [
		anObject isCharacter and:[anObject isOctetCharacter not]]) ifTrue: [
			collection := (WideString from: collection).
			^self nextPut: anObject.
	].
	position >= writeLimit
		ifTrue: [^ self pastEndPut: anObject]
		ifFalse: 
			[position := position + 1.
			^collection at: position put: anObject]! !

!Process methodsFor: '*LRSTM-Model' stamp: 'lr 5/30/2007 12:09'!
currentTransaction
	^ currentTransaction! !

!Process methodsFor: '*LRSTM-Model' stamp: 'lr 5/30/2007 12:09'!
currentTransaction: aTransaction
	currentTransaction := aTransaction! !

!BlockContext methodsFor: '*LRSTM-Model' stamp: 'StefanMarr 6/4/2013 15:29'!
atomic
	^ LRSTMTransaction createNew do: self! !

!BlockContext methodsFor: '*LRSTM-Model' stamp: 'StefanMarr 6/4/2013 15:29'!
atomicIfConflict: aBlock
	^ LRSTMTransaction createNew do: self ifConflict: aBlock! !

!BlockContext methodsFor: '*LRSTM-Model' stamp: 'StefanMarr 6/4/2013 15:29'!
atomicRetry
	^ LRSTMTransaction createNew retry: self! !

!ReadStream methodsFor: '*LRSTM-Model' stamp: 'lr 6/7/2007 15:16'!
atomicNext
	^ position >= readLimit
		ifFalse: [ collection at: (position := position + 1) ]! !

!BlockClosure methodsFor: '*LRSTM-Model' stamp: 'StefanMarr 6/4/2013 15:28'!
atomic
	^ LRSTMTransaction createNew do: self! !

!BlockClosure methodsFor: '*LRSTM-Model' stamp: 'StefanMarr 6/4/2013 15:28'!
atomicIfConflict: aBlock
	^ LRSTMTransaction createNew do: self ifConflict: aBlock! !

!BlockClosure methodsFor: '*LRSTM-Model' stamp: 'StefanMarr 6/4/2013 15:28'!
atomicRetry
	^ LRSTMTransaction createNew retry: self! !

!ContextPart methodsFor: '*LRSTM-Model' stamp: 'lr 5/31/2007 15:49'!
workingCopy
	^ self! !

Error subclass: #LRSTMConflict
	instanceVariableNames: 'transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Model-Errors'!

!LRSTMConflict methodsFor: 'accessing' stamp: 'lr 5/25/2007 09:04'!
transaction
	^ transaction! !

!LRSTMConflict methodsFor: 'accessing' stamp: 'lr 5/25/2007 09:04'!
transaction: aTransaction
	transaction := aTransaction! !

Error subclass: #LRSTMInvalidTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Model-Errors'!

Object subclass: #LRSTMChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Model'!

!LRSTMChange methodsFor: 'actions' stamp: 'lr 6/8/2007 16:59'!
apply
	self subclassResponsibility! !

!LRSTMChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasChanged
	^ true! !

!LRSTMChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasConflict
	^ false! !

LRSTMChange subclass: #LRSTMCustomChange
	instanceVariableNames: 'applyBlock conflictTestBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Model'!

!LRSTMCustomChange class methodsFor: 'instance-creation' stamp: 'StefanMarr 6/4/2013 13:46'!
onApply: anApplyBlock
	<omniUnenforced>
	^ self onApply: anApplyBlock onConflictTest: [ false ]! !

!LRSTMCustomChange class methodsFor: 'instance-creation' stamp: 'StefanMarr 6/4/2013 13:46'!
onApply: anApplyBlock onConflictTest: aConflictTestBlock
	<omniUnenforced>
	^ self basicNew initializeApply: anApplyBlock conflictTest: aConflictTestBlock! !

!LRSTMCustomChange methodsFor: 'actions' stamp: 'lr 2/26/2008 16:26'!
apply
	applyBlock value! !

!LRSTMCustomChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:28'!
hasConflict
	^ conflictTestBlock value! !

!LRSTMCustomChange methodsFor: 'initialization' stamp: 'lr 6/8/2007 17:04'!
initializeApply: anApplyBlock conflictTest: aConflictTestBlock	
	applyBlock := anApplyBlock.
	conflictTestBlock := aConflictTestBlock! !

LRSTMChange subclass: #LRSTMObjectChange
	instanceVariableNames: 'original previous working'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Model'!

!LRSTMObjectChange class methodsFor: 'instance-creation' stamp: 'lr 6/8/2007 16:59'!
on: anObject
	^ self basicNew initializeOn: anObject! !

!LRSTMObjectChange methodsFor: 'actions' stamp: 'lr 6/8/2007 16:59'!
apply
	original restoreSnapshot: working! !

!LRSTMObjectChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasChanged
	^ (working isIdenticalToSnapshot: previous) not! !

!LRSTMObjectChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasConflict
	^ (original isIdenticalToSnapshot: previous) not! !

!LRSTMObjectChange methodsFor: 'initialization' stamp: 'lr 6/8/2007 16:59'!
initializeOn: anObject
	original := anObject.
	working := original snapshotCopy.
	previous := working snapshotCopy! !

!LRSTMObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
original
	^ original! !

!LRSTMObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
previous
	^ previous! !

!LRSTMObjectChange methodsFor: 'printing' stamp: 'lr 6/8/2007 17:01'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' ['; print: self original; nextPut: $]! !

!LRSTMObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
working
	^ working! !

Object subclass: #LRSTMTransaction
	instanceVariableNames: 'parent context changes objectChanges'
	classVariableNames: 'TransactionCls'
	poolDictionaries: 'ContextPart'
	category: 'LRSTM-Model'!

LRSTMTransaction subclass: #LRSTMTracingTransaction
	instanceVariableNames: 'changesForCnt changedObjectClasses ctxs associations strings'
	classVariableNames: 'TransactionLog'
	poolDictionaries: ''
	category: 'LRSTM-Model'!

!LRSTMTracingTransaction class methodsFor: 'class initialization' stamp: 'StefanMarr 6/4/2013 15:29'!
initialize
	TransactionLog := OrderedCollection new.! !

!LRSTMTracingTransaction class methodsFor: 'instance creation' stamp: 'StefanMarr 6/4/2013 15:31'!
new
	<omniUnenforced>
	| tx |
	tx := super new.
	TransactionLog add: tx.
	^ tx! !

!LRSTMTracingTransaction class methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 15:34'!
transactionLog
	^ TransactionLog! !

!LRSTMTracingTransaction methodsFor: 'accessing' stamp: 'StefanMarr 6/5/2013 17:08'!
changeFor: anObject
	<omniUnenforced>
	| clsCnt |
	changesForCnt := changesForCnt + 1.
	clsCnt := changedObjectClasses at: anObject class ifAbsent: 0.
	changedObjectClasses at: anObject class put: clsCnt + 1.
	
	anObject class == Association ifTrue: [
		| cnt |
		cnt := associations at: anObject key ifAbsent: 0.
		associations at: anObject key put: cnt + 1.
		
		"anObject key == #String ifTrue: [Halt now]"
		].
	
	"anObject class == Association ifTrue: [
		ctxs add: {
		thisContext sender.
		thisContext sender sender.
		thisContext sender sender sender.
		thisContext sender sender sender sender.
		thisContext sender sender sender sender sender.
		thisContext sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender sender sender.
		}.
		]."
	
	^ super changeFor: anObject! !

!LRSTMTracingTransaction methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 22:46'!
changedObjectClasses
	^ changedObjectClasses! !

!LRSTMTracingTransaction methodsFor: 'initialize-release' stamp: 'StefanMarr 6/5/2013 16:48'!
initialize 
	super initialize.
	changesForCnt := 0.
	changedObjectClasses := IdentityDictionary new.
	ctxs := OrderedCollection new.
	associations := IdentityDictionary new.
	strings := OrderedCollection new.! !

!LRSTMTracingTransaction methodsFor: 'initialize-release' stamp: 'StefanMarr 6/4/2013 15:35'!
numberOfChangeForRequests
	^ changesForCnt! !

!LRSTMTransaction class methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 15:23'!
TransactionClass
	^ TransactionCls! !

!LRSTMTransaction class methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 15:23'!
TransactionClass: aTransactionClass
	TransactionCls := aTransactionClass! !

!LRSTMTransaction class methodsFor: 'instance creation' stamp: 'StefanMarr 6/4/2013 15:28'!
createNew
	^ TransactionCls new! !

!LRSTMTransaction class methodsFor: 'initialization' stamp: 'StefanMarr 6/11/2013 17:13'!
initializeLRSTM
	(Process hasInstVarNamed: #currentTransaction) ifFalse: [
		Process addInstVarNamed: #currentTransaction.
	].

	TransactionCls := self.! !

!LRSTMTransaction class methodsFor: 'initialize-release' stamp: 'StefanMarr 6/11/2013 16:03'!
unloadLRSTM
	(Process hasInstVarNamed: #currentTransaction) ifTrue: [
		Process removeInstVarNamed: #currentTransaction.
	]! !

!LRSTMTransaction methodsFor: 'private' stamp: 'StefanMarr 6/4/2013 13:43'!
abort
	"Abort a transaction."
	
	<omniUnenforced>
	parent := context := changes := objectChanges := nil! !

!LRSTMTransaction methodsFor: 'public' stamp: 'StefanMarr 6/4/2013 13:43'!
abort: aValue
	"Abort a transaction."
	
	<omniUnenforced>
	Processor activeProcess currentTransaction: parent.
	thisContext swapSender: context.
	self abort.
	^ aValue! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 13:43'!
addChange: aChange
	<omniUnenforced>
	^ changes add: aChange! !

!LRSTMTransaction methodsFor: 'private' stamp: 'StefanMarr 6/4/2013 13:44'!
begin
	"Start a transaction. If this is a nested transaction copy the parent changes into our own context."
	
	<omniUnenforced>
	changes := OrderedCollection new.
	objectChanges := IdentityDictionary new.
	self isNested ifTrue: [
		parent objectChanges
			keysAndValuesDo: [ :key :value | objectChanges at: key put: value copy ] ]! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 13:45'!
changeFor: anObject
	<omniUnenforced>
	^ objectChanges at: anObject ifAbsentPut: [ self addChange: (LRSTMObjectChange on: anObject) ]! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 13:45'!
changes
	"Answer an ordered collection of unique changes."

	<omniUnenforced>
	^ changes! !

!LRSTMTransaction methodsFor: 'public' stamp: 'StefanMarr 6/4/2013 13:45'!
checkpoint
	"Checkpoint a transaction."

	<omniUnenforced>
	self commit; begin! !

!LRSTMTransaction methodsFor: 'private' stamp: 'StefanMarr 6/4/2013 13:45'!
commit
	"Commit a transaction."

	<omniUnenforced>
	self commitIfConflict: [ self signalConflict ]! !

!LRSTMTransaction methodsFor: 'private' stamp: 'StefanMarr 6/4/2013 13:45'!
commitIfConflict: aBlock
	"Commit a transaction atomically."
	
	<omniUnenforced>
	[	changes do: [ :each |
			each hasConflict
				ifTrue: [ ^ aBlock value ] ].
		self isNested 
			ifTrue: [
				objectChanges keysAndValuesDo: [ :key :value |
					(parent objectChanges includesKey: key)
						ifFalse: [ parent addChange: value ].
					parent objectChanges at: key put: value ] ]
			ifFalse: [ 	
				changes do: [ :each |
					each hasChanged
						ifTrue: [ each apply ] ] ] ]
		valueUnpreemptively! !

!LRSTMTransaction methodsFor: 'public' stamp: 'StefanMarr 6/4/2013 13:45'!
do: aBlock
	"Start a transaction with aBlock."

	<omniUnenforced>		
	^ self do: aBlock ifConflict: [ self signalConflict ]! !

!LRSTMTransaction methodsFor: 'testing' stamp: 'StefanMarr 6/4/2013 13:46'!
isNested
	<omniUnenforced>
	^ parent notNil! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 13:46'!
objectChanges
	<omniUnenforced>
	^ objectChanges! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'StefanMarr 6/4/2013 13:46'!
parent
	<omniUnenforced>
	^ parent! !

!LRSTMTransaction methodsFor: 'public' stamp: 'StefanMarr 6/4/2013 13:48'!
retry: aBlock
	"Unconditionally retry to evaluate aBlock until there are no conflict."

	<omniUnenforced>
	^ self do: aBlock ifConflict: [ self retry: aBlock ]! !

!LRSTMTransaction methodsFor: 'private' stamp: 'StefanMarr 6/4/2013 13:48'!
signalConflict
	<omniUnenforced>
	^ LRSTMConflict new transaction: self; signal! !

!Object methodsFor: '*LRSTM-Model' stamp: 'lr 6/7/2007 15:05'!
isIdenticalToSnapshot: anObject
	1 to: self class instSize do: [ :index | 
		(self instVarAt: index) == (anObject instVarAt: index)
			ifFalse: [ ^ false ] ].
	self class isVariable ifTrue: [
		1 to: self size do: [ :index | 
			(self at: index) == (anObject at: index)
				ifFalse: [ ^ false ] ] ].
	^ true! !

!Object methodsFor: '*LRSTM-Model' stamp: 'lr 6/7/2007 13:47'!
restoreSnapshot: anObject
	<primitive: 168>
	self primitiveFailed! !

!Object methodsFor: '*LRSTM-Model' stamp: 'lr 6/7/2007 13:48'!
snapshotCopy
	<primitive: 148>
	self primitiveFailed! !

!Object methodsFor: '*LRSTM-Model' stamp: 'lr 5/30/2007 12:11'!
workingCopy
	"Answer a working copy to be used within the context of the current transaction."
	
	| transaction |
	transaction := Processor activeProcess currentTransaction
		ifNil: [ self error: 'No active transaction' ].
	^ (transaction changeFor: self) working! !
LRSTMTracingTransaction initialize!
